'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _style = require('./style.css');

var _style2 = _interopRequireDefault(_style);

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Progress = function (_Component) {
  (0, _inherits3.default)(Progress, _Component);

  function Progress(props) {
    (0, _classCallCheck3.default)(this, Progress);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Progress).call(this, props));

    _this.state = { percent: props.percent };
    return _this;
  }

  (0, _createClass3.default)(Progress, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (this.state.percent < 1) this.start();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      clearInterval(this.interval);
    }
  }, {
    key: 'start',
    value: function start() {
      clearInterval(this.interval);
      var p = this.state.percent;
      var inc = this.props.inc;
      if (!inc) return;
      this.interval = window.setInterval(function () {
        p = this.state.percent + inc / 5;
        if (p >= 0.95) window.clearInterval(this.interval);
        this.setState({
          percent: p
        });
      }.bind(this), 200);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(props) {
      var p = props.percent;
      var sp = this.state.percent;
      if (p > 0 && p < sp && sp < 1) return;
      this.setState({
        percent: p
      });
      if (p > 1 || p < 0) return;
      this.start();
    }
  }, {
    key: 'render',
    value: function render() {
      var props = this.props;
      var p = props.percent;
      var styles = (0, _objectAssign2.default)({
        backgroundColor: props.color,
        boxShadow: '0 0 4px ' + props.color
      }, props.style, {
        width: 100 * this.state.percent + '%'
      });
      var clz = (0, _classnames2.default)(props.className, _style2.default.progress, (0, _defineProperty3.default)({}, _style2.default.hide, p >= 1));
      return _react2.default.createElement('div', { className: clz, style: styles });
    }
  }]);
  return Progress;
}(_react.Component);

Progress.displayName = 'rc-progress';
Progress.defaultProps = {
  color: '#29d',
  inc: 0
};
Progress.propTypes = {
  inc: function inc(props, propName) {
    var inc = props[propName];
    if (typeof inc !== 'number') throw new Error(propName + ' should be number');
    if (inc < 0 || inc > 1) throw new Error(propName + 'shoudl be 0 to 1');
  },
  percent: _propTypes2.default.number.isRequired,
  color: _propTypes2.default.string
};
exports.default = Progress;